// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{prelude::*, translate::*};
use std::fmt;

#[derive(Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Clone, Copy)]
#[non_exhaustive]
#[doc(alias = "GspellCheckerError")]
pub enum CheckerError {
    #[doc(alias = "GSPELL_CHECKER_ERROR_DICTIONARY")]
    Dictionary,
    #[doc(alias = "GSPELL_CHECKER_ERROR_NO_LANGUAGE_SET")]
    NoLanguageSet,
    #[doc(hidden)]
    __Unknown(i32),
}

impl fmt::Display for CheckerError {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(
            f,
            "CheckerError::{}",
            match *self {
                Self::Dictionary => "Dictionary",
                Self::NoLanguageSet => "NoLanguageSet",
                _ => "Unknown",
            }
        )
    }
}

#[doc(hidden)]
impl IntoGlib for CheckerError {
    type GlibType = ffi::GspellCheckerError;

    #[inline]
    fn into_glib(self) -> ffi::GspellCheckerError {
        match self {
            Self::Dictionary => ffi::GSPELL_CHECKER_ERROR_DICTIONARY,
            Self::NoLanguageSet => ffi::GSPELL_CHECKER_ERROR_NO_LANGUAGE_SET,
            Self::__Unknown(value) => value,
        }
    }
}

#[doc(hidden)]
impl FromGlib<ffi::GspellCheckerError> for CheckerError {
    #[inline]
    unsafe fn from_glib(value: ffi::GspellCheckerError) -> Self {
        skip_assert_initialized!();

        match value {
            ffi::GSPELL_CHECKER_ERROR_DICTIONARY => Self::Dictionary,
            ffi::GSPELL_CHECKER_ERROR_NO_LANGUAGE_SET => Self::NoLanguageSet,
            value => Self::__Unknown(value),
        }
    }
}

impl glib::error::ErrorDomain for CheckerError {
    #[inline]
    fn domain() -> glib::Quark {
        skip_assert_initialized!();

        unsafe { from_glib(ffi::gspell_checker_error_quark()) }
    }

    #[inline]
    fn code(self) -> i32 {
        self.into_glib()
    }

    #[inline]
    #[allow(clippy::match_single_binding)]
    fn from(code: i32) -> Option<Self> {
        skip_assert_initialized!();
        match unsafe { from_glib(code) } {
            value => Some(value),
        }
    }
}

impl StaticType for CheckerError {
    #[inline]
    #[doc(alias = "gspell_checker_error_get_type")]
    fn static_type() -> glib::Type {
        unsafe { from_glib(ffi::gspell_checker_error_get_type()) }
    }
}

impl glib::HasParamSpec for CheckerError {
    type ParamSpec = glib::ParamSpecEnum;
    type SetValue = Self;
    type BuilderFn = fn(&str, Self) -> glib::ParamSpecEnumBuilder<Self>;

    fn param_spec_builder() -> Self::BuilderFn {
        Self::ParamSpec::builder_with_default
    }
}

impl glib::value::ValueType for CheckerError {
    type Type = Self;
}

unsafe impl<'a> glib::value::FromValue<'a> for CheckerError {
    type Checker = glib::value::GenericValueTypeChecker<Self>;

    #[inline]
    unsafe fn from_value(value: &'a glib::Value) -> Self {
        skip_assert_initialized!();
        from_glib(glib::gobject_ffi::g_value_get_enum(value.to_glib_none().0))
    }
}

impl ToValue for CheckerError {
    #[inline]
    fn to_value(&self) -> glib::Value {
        let mut value = glib::Value::for_value_type::<Self>();
        unsafe {
            glib::gobject_ffi::g_value_set_enum(value.to_glib_none_mut().0, self.into_glib());
        }
        value
    }

    #[inline]
    fn value_type(&self) -> glib::Type {
        Self::static_type()
    }
}

impl From<CheckerError> for glib::Value {
    #[inline]
    fn from(v: CheckerError) -> Self {
        skip_assert_initialized!();
        ToValue::to_value(&v)
    }
}
